#if defined (__AVR_ATtiny2313__)
#	define NO_XTAL		/* Tiny2313ȂOUqgȂ */
#endif
#define F_CPU 8e6		/* VXeNbNg[Hz] */
#define F_TICK 360		/* 1bԂ̃^C}[荞݂̉[Hz] */
#define TM0_PRESCALE 256	/* ^C}[0̑Ou */
#define TM0_COUNTS ((uint8_t)(F_CPU / TM0_PRESCALE / F_TICK + 0.5)) /* ^C}[荞݂̎[counts] */

#define CPI 20480		/* XP[̐x[count/inch] */
#define MPI 25.4		/* inch/mm */
#define CONV_MUL_INCH (1000 / 40)
#define CONV_DIV_INCH (CPI / 40)
#define CONV_MUL_MM ((uint32_t)(MPI * 100) / 20)
#define CONV_DIV_MM (CPI / 20)

#define UPDATE_IVL_MS 250	/* XP[̃f[^XVԊu[ms]ilj */
#define TM1_PRESCALE 256	/* ^C}[1̑Ou */
#define UPDATE_IVL ((uint16_t)(UPDATE_IVL_MS * F_CPU / TM1_PRESCALE / 1000))

#define UNIT_MM 0
#define UNIT_INCH 1
#define COM_DP_MM 3		/* mm\ɏ_uCOMʒu */
#define COM_DP_INCH 2		/* inch\ɏ_uCOMʒu */

// for scale port
#define SCALE_PORT PORTD
#define SCALE_PIN PIND
#define SCALE_DDR DDRD
#define SCALE_CK_BIT 3
#define SCALE_DA_BIT 2
#define SCALE_ZERO_BIT 1

#define scale_zero_on() SCALE_PORT |= _BV(SCALE_ZERO_BIT)
#define scale_zero_off() SCALE_PORT &= ~_BV(SCALE_ZERO_BIT)

// for LED ports
#define LED_COM_PORT PORTD
#define LED_COM_DDR DDRD
#define LED_COM_BIT0 4
#define LED_COM_BIT1 5
#define LED_COM_BIT2 6
#define LED_COM_MAX 6
#define LED_SEG_PORT PORTB
#define LED_SEG_DDR DDRB
#define LED_SEG_A_BIT 7
#define LED_SEG_B_BIT 6
#define LED_SEG_C_BIT 5
#define LED_SEG_D_BIT 4
#define LED_SEG_E_BIT 3
#define LED_SEG_F_BIT 2
#define LED_SEG_G_BIT 1
#define LED_SEG_H_BIT 0		/* _ */

#define LED_MINUS 16
#define LED_BLANK 17

#define led_on(segno) LED_SEG_PORT &= ~_BV(segno)
#define led_off(segno) LED_SEG_PORT |= _BV(segno)

// for keys
#define KEY_SENSE_PORT PORTD
#define KEY_SENSE_DDR DDRD
#define KEY_SENSE_PIN PIND
#define KEY_SENSE_BIT 0

#define KEY_ZERO_BIT 0
#define KEY_UNIT_BIT 1

#define KEY_DEBOUNCE_MS 10	/* `^O[ms] */
#define KEY_DEBOUNCE (KEY_DEBOUNCE_MS * F_TICK / 1000)

#define ZERO_DURATION_SEC 0.7	/* [NApX[s] */
#define ZERO_DURATION (ZERO_DURATION_SEC * F_TICK)
