#include <avr/io.h>
#include <avr/pgmspace.h>

#include "defines.h"
#include "globals.h"
#include "functions.h"

uint8_t Seg7Font[] PROGMEM = {
	//abcdefgh
	0b00000011,	/* 0 */
	0b10011111,	/* 1 */
	0b00100101,	/* 2 */
	0b00001101,	/* 3 */
	0b10011001,	/* 4 */
	0b01001001,	/* 5 */
	0b01000001,	/* 6 */
	0b00011011,	/* 7 */
	0b00000001,	/* 8 */
	0b00001001,	/* 9 */
	0b11101111,	/* A */
	0b00111111,	/* B */
	0b10011101,	/* C */
	0b01111011,	/* D */
	0b10011111,	/* E */
	0b10001111,	/* F */
	0b11111101,	/* - */
	0b11111111,	/* blank */
};

#if 0
void led_on(uint8_t segno)
{
	LED_SEG_PORT &= ~_BV(segno);
}

void led_off(uint8_t segno)
{
	LED_SEG_PORT |= _BV(segno);
}
#endif

void led_seg(uint8_t fontno)
{
	LED_SEG_PORT = pgm_read_byte(&Seg7Font[fontno]);
}

void lamptest(void)
{
	int8_t i;

	for (i = 5; i >= 0; --i) {
		Segment[i] = 0x88; /* "8" and "." */
		while(TCNT1 < (UPDATE_IVL / 4)); /* UPDATE_IVLĝɓɈӖ͂Ȃ */
		TCNT1 = 0;
	}

	for (i = 5; i >= 0; --i) {
		Segment[i] = LED_BLANK;
		while(TCNT1 < (UPDATE_IVL / 4));
		TCNT1 = 0;
	}
}
