#include "defines.h"
#include <avr/io.h>
#include <avr/interrupt.h>
#include "functions.h"
#include "globals.h"

// 1/F_TICKb1̃XLp^C}[荞
#if defined (__AVR_AT90S2313__)
ISR(TIMER0_OVF0_vect)
{
	TCNT0 = 0xff - TM0_COUNTS; /* vZbgȂ */
#else  /* defined (__AVR_ATtiny2313__) */
ISR(TIMER0_COMPA_vect)
{
#endif

	uint8_t work, com;

	sei();			/* XP[̊荞݂ */

	com = Common;

	// COMԍ̑I
	work = LED_COM_PORT & 0b0001111;
	LED_COM_PORT = work | (uint8_t)(com << LED_COM_BIT0);
	
	// e̐\
	work = Segment[com];
	led_seg(work & 0x7f);	/* 7bitl */
	if (work & 0x80)
		led_on(LED_SEG_H_BIT); /* bit7=1Ȃ珬__ */

	// L[̌o
	work = Key[com];
	if ((KEY_SENSE_PIN & _BV(KEY_SENSE_BIT)) == 0) {
		if (work < 250)
			++work;	/* ĂԂ250܂ő */
	} else {
		work = 0;	/* ƃ[ */
	}
	Key[com] = work;

	if (com == LED_COM_MAX)
		Common = 0;
	else
		Common = com + 1;
}

// XP[̃f[^荞݁BoGbW͗オGbWB
ISR(INT1_vect)
{
	*Rbufp++ = SCALE_PIN;	/* f[^𗎂ƂȂ悤ɂƂ肠ǂŃobt@ɂ߂ */
	if (Rbufp >= Rbuf + sizeof(Rbuf)) { /* obt@܂œB */
		Rbufp = Rbuf + sizeof(Rbuf) - 1; /* ɖ߂炸ɂő݂Ă */
		Updated = 1;	/* f[^XVꂽƂmain()ɒʒm */
	}
	TCNT1 = 0;		/* f[^MԊuvp^C}[NA */
}

// XP[̃f[^MԊu𑪂
#if defined (__AVR_AT90S2313__)
ISR(TIMER1_COMP1_vect)
#else  /* defined (__AVR_ATtiny2313__) */
ISR(TIMER1_COMPA_vect)
#endif
{
	Rbufp = Rbuf;		/* ԊuJĂ玟̓f[^̓obt@|C^擪 */
}

void init_int1(void)
{
	MCUCR = 0b11 << ISC10;	/* オGbWZX */
	GIMSK = _BV(INT1);
}

